package io.github.zskamljic.restahead.demo;

import io.github.zskamljic.restahead.adapter.DefaultAdapters;
import io.github.zskamljic.restahead.client.Client;
import io.github.zskamljic.restahead.client.requests.Request;
import io.github.zskamljic.restahead.client.requests.Verb;
import io.github.zskamljic.restahead.conversion.MapFormConverter;
import io.github.zskamljic.restahead.exceptions.RestException;
import java.lang.Double;
import java.lang.Integer;
import java.lang.InterruptedException;
import java.lang.Override;
import java.lang.String;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.ExecutionException;
import javax.annotation.processing.Generated;

@Generated("Generated by RestAhead")
public final class FormOnValidMap$Impl implements FormOnValidMap {
    private final String baseUrl;

    private final Client client;

    private final DefaultAdapters defaultAdapters;

    public FormOnValidMap$Impl(String baseUrl, Client client, DefaultAdapters defaultAdapters) {
        this.baseUrl = baseUrl;
        this.client = client;
        this.defaultAdapters = defaultAdapters;
    }

    @Override
    public final void post(Map<String, String> body) {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.POST)
            .setBaseUrl(baseUrl)
            .setPath("");
        httpRequestBuilder.addHeader("Content-Type", "application/x-www-form-urlencoded");
        httpRequestBuilder.setBody(MapFormConverter.formEncode(body));
        var response = client.execute(httpRequestBuilder.build());
        try {
            defaultAdapters.syncVoidAdapter(response);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }

    @Override
    public final void post2(Map<String, UUID> body) {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.POST)
            .setBaseUrl(baseUrl)
            .setPath("");
        httpRequestBuilder.addHeader("Content-Type", "application/x-www-form-urlencoded");
        httpRequestBuilder.setBody(MapFormConverter.formEncode(body));
        var response = client.execute(httpRequestBuilder.build());
        try {
            defaultAdapters.syncVoidAdapter(response);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }

    @Override
    public final void post3(Map<String, Integer> body) {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.POST)
            .setBaseUrl(baseUrl)
            .setPath("");
        httpRequestBuilder.addHeader("Content-Type", "application/x-www-form-urlencoded");
        httpRequestBuilder.setBody(MapFormConverter.formEncode(body));
        var response = client.execute(httpRequestBuilder.build());
        try {
            defaultAdapters.syncVoidAdapter(response);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }

    @Override
    public final void post4(HashMap<String, Double> body) {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.POST)
            .setBaseUrl(baseUrl)
            .setPath("");
        httpRequestBuilder.addHeader("Content-Type", "application/x-www-form-urlencoded");
        httpRequestBuilder.setBody(MapFormConverter.formEncode(body));
        var response = client.execute(httpRequestBuilder.build());
        try {
            defaultAdapters.syncVoidAdapter(response);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }
}